// kafka-connector options: START
[[camel-salesforce-kafka-connector-sink]]
= camel-salesforce-kafka-connector sink configuration

When using camel-salesforce-kafka-connector as sink make sure to use the following Maven dependency to have support for the connector:

[source,xml]
----
<dependency>
  <groupId>org.apache.camel.kafkaconnector</groupId>
  <artifactId>camel-salesforce-kafka-connector</artifactId>
  <version>x.x.x</version>
  <!-- use the same version as your Camel Kafka connector version -->
</dependency>
----

To use this Sink connector in Kafka connect you'll need to set the following connector.class

[source,java]
----
connector.class=org.apache.camel.kafkaconnector.salesforce.CamelSalesforceSinkConnector
----


The camel-salesforce sink connector supports 115 options, which are listed below.



[width="100%",cols="2,5,^1,1,1",options="header"]
|===
| Name | Description | Default | Required | Priority
| *camel.sink.path.operationName* | The operation to use One of: [getVersions] [getResources] [getGlobalObjects] [getBasicInfo] [getDescription] [getSObject] [createSObject] [updateSObject] [deleteSObject] [getSObjectWithId] [upsertSObject] [deleteSObjectWithId] [getBlobField] [query] [queryMore] [queryAll] [search] [apexCall] [recent] [createJob] [getJob] [closeJob] [abortJob] [createBatch] [getBatch] [getAllBatches] [getRequest] [getResults] [createBatchQuery] [getQueryResultIds] [getQueryResult] [getRecentReports] [getReportDescription] [executeSyncReport] [executeAsyncReport] [getReportInstances] [getReportResults] [limits] [approval] [approvals] [composite-tree] [composite-batch] [composite] | null | false | MEDIUM
| *camel.sink.endpoint.apexMethod* | APEX method name | null | false | MEDIUM
| *camel.sink.endpoint.apexQueryParams* | Query params for APEX method | null | false | MEDIUM
| *camel.sink.endpoint.apiVersion* | Salesforce API version. | "50.0" | false | MEDIUM
| *camel.sink.endpoint.backoffIncrement* | Backoff interval increment for Streaming connection restart attempts for failures beyond CometD auto-reconnect. | 1000L | false | MEDIUM
| *camel.sink.endpoint.batchId* | Bulk API Batch ID | null | false | MEDIUM
| *camel.sink.endpoint.contentType* | Bulk API content type, one of XML, CSV, ZIP_XML, ZIP_CSV One of: [XML] [CSV] [JSON] [ZIP_XML] [ZIP_CSV] [ZIP_JSON] | null | false | MEDIUM
| *camel.sink.endpoint.defaultReplayId* | Default replayId setting if no value is found in initialReplayIdMap | "-1" | false | MEDIUM
| *camel.sink.endpoint.format* | Payload format to use for Salesforce API calls, either JSON or XML, defaults to JSON One of: [JSON] [XML] | null | false | MEDIUM
| *camel.sink.endpoint.httpClient* | Custom Jetty Http Client to use to connect to Salesforce. | null | false | MEDIUM
| *camel.sink.endpoint.includeDetails* | Include details in Salesforce1 Analytics report, defaults to false. | null | false | MEDIUM
| *camel.sink.endpoint.initialReplayIdMap* | Replay IDs to start from per channel name. | null | false | MEDIUM
| *camel.sink.endpoint.instanceId* | Salesforce1 Analytics report execution instance ID | null | false | MEDIUM
| *camel.sink.endpoint.jobId* | Bulk API Job ID | null | false | MEDIUM
| *camel.sink.endpoint.limit* | Limit on number of returned records. Applicable to some of the API, check the Salesforce documentation. | null | false | MEDIUM
| *camel.sink.endpoint.maxBackoff* | Maximum backoff interval for Streaming connection restart attempts for failures beyond CometD auto-reconnect. | 30000L | false | MEDIUM
| *camel.sink.endpoint.notFoundBehaviour* | Sets the behaviour of 404 not found status received from Salesforce API. Should the body be set to NULL NotFoundBehaviour#NULL or should a exception be signaled on the exchange NotFoundBehaviour#EXCEPTION - the default. One of: [EXCEPTION] [NULL] | "EXCEPTION" | false | MEDIUM
| *camel.sink.endpoint.notifyForFields* | Notify for fields, options are ALL, REFERENCED, SELECT, WHERE One of: [ALL] [REFERENCED] [SELECT] [WHERE] | null | false | MEDIUM
| *camel.sink.endpoint.notifyForOperationCreate* | Notify for create operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.sink.endpoint.notifyForOperationDelete* | Notify for delete operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.sink.endpoint.notifyForOperations* | Notify for operations, options are ALL, CREATE, EXTENDED, UPDATE (API version 29.0) One of: [ALL] [CREATE] [EXTENDED] [UPDATE] | null | false | MEDIUM
| *camel.sink.endpoint.notifyForOperationUndelete* | Notify for un-delete operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.sink.endpoint.notifyForOperationUpdate* | Notify for update operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.sink.endpoint.objectMapper* | Custom Jackson ObjectMapper to use when serializing/deserializing Salesforce objects. | null | false | MEDIUM
| *camel.sink.endpoint.rawPayload* | Use raw payload String for request and response (either JSON or XML depending on format), instead of DTOs, false by default | false | false | MEDIUM
| *camel.sink.endpoint.reportId* | Salesforce1 Analytics report Id | null | false | MEDIUM
| *camel.sink.endpoint.reportMetadata* | Salesforce1 Analytics report metadata for filtering | null | false | MEDIUM
| *camel.sink.endpoint.resultId* | Bulk API Result ID | null | false | MEDIUM
| *camel.sink.endpoint.sObjectBlobFieldName* | SObject blob field name | null | false | MEDIUM
| *camel.sink.endpoint.sObjectClass* | Fully qualified SObject class name, usually generated using camel-salesforce-maven-plugin | null | false | MEDIUM
| *camel.sink.endpoint.sObjectFields* | SObject fields to retrieve | null | false | MEDIUM
| *camel.sink.endpoint.sObjectId* | SObject ID if required by API | null | false | MEDIUM
| *camel.sink.endpoint.sObjectIdName* | SObject external ID field name | null | false | MEDIUM
| *camel.sink.endpoint.sObjectIdValue* | SObject external ID field value | null | false | MEDIUM
| *camel.sink.endpoint.sObjectName* | SObject name if required or supported by API | null | false | MEDIUM
| *camel.sink.endpoint.sObjectQuery* | Salesforce SOQL query string | null | false | MEDIUM
| *camel.sink.endpoint.sObjectSearch* | Salesforce SOSL search string | null | false | MEDIUM
| *camel.sink.endpoint.updateTopic* | Whether to update an existing Push Topic when using the Streaming API, defaults to false | false | false | MEDIUM
| *camel.sink.endpoint.apexUrl* | APEX method URL | null | false | MEDIUM
| *camel.sink.endpoint.compositeMethod* | Composite (raw) method. | null | false | MEDIUM
| *camel.sink.endpoint.lazyStartProducer* | Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing. | false | false | MEDIUM
| *camel.sink.endpoint.synchronous* | Sets whether synchronous processing should be strictly used, or Camel is allowed to use asynchronous processing (if supported). | false | false | MEDIUM
| *camel.component.salesforce.apexMethod* | APEX method name | null | false | MEDIUM
| *camel.component.salesforce.apexQueryParams* | Query params for APEX method | null | false | MEDIUM
| *camel.component.salesforce.apiVersion* | Salesforce API version. | "50.0" | false | MEDIUM
| *camel.component.salesforce.backoffIncrement* | Backoff interval increment for Streaming connection restart attempts for failures beyond CometD auto-reconnect. | 1000L | false | MEDIUM
| *camel.component.salesforce.batchId* | Bulk API Batch ID | null | false | MEDIUM
| *camel.component.salesforce.contentType* | Bulk API content type, one of XML, CSV, ZIP_XML, ZIP_CSV One of: [XML] [CSV] [JSON] [ZIP_XML] [ZIP_CSV] [ZIP_JSON] | null | false | MEDIUM
| *camel.component.salesforce.defaultReplayId* | Default replayId setting if no value is found in initialReplayIdMap | "-1" | false | MEDIUM
| *camel.component.salesforce.format* | Payload format to use for Salesforce API calls, either JSON or XML, defaults to JSON One of: [JSON] [XML] | null | false | MEDIUM
| *camel.component.salesforce.httpClient* | Custom Jetty Http Client to use to connect to Salesforce. | null | false | MEDIUM
| *camel.component.salesforce.httpClientConnection Timeout* | Connection timeout used by the HttpClient when connecting to the Salesforce server. | 60000L | false | MEDIUM
| *camel.component.salesforce.httpClientIdleTimeout* | Timeout used by the HttpClient when waiting for response from the Salesforce server. | 10000L | false | MEDIUM
| *camel.component.salesforce.httpMaxContentLength* | Max content length of an HTTP response. | null | false | MEDIUM
| *camel.component.salesforce.httpRequestBufferSize* | HTTP request buffer size. May need to be increased for large SOQL queries. | "8192" | false | MEDIUM
| *camel.component.salesforce.includeDetails* | Include details in Salesforce1 Analytics report, defaults to false. | null | false | MEDIUM
| *camel.component.salesforce.initialReplayIdMap* | Replay IDs to start from per channel name. | null | false | MEDIUM
| *camel.component.salesforce.instanceId* | Salesforce1 Analytics report execution instance ID | null | false | MEDIUM
| *camel.component.salesforce.jobId* | Bulk API Job ID | null | false | MEDIUM
| *camel.component.salesforce.limit* | Limit on number of returned records. Applicable to some of the API, check the Salesforce documentation. | null | false | MEDIUM
| *camel.component.salesforce.maxBackoff* | Maximum backoff interval for Streaming connection restart attempts for failures beyond CometD auto-reconnect. | 30000L | false | MEDIUM
| *camel.component.salesforce.notFoundBehaviour* | Sets the behaviour of 404 not found status received from Salesforce API. Should the body be set to NULL NotFoundBehaviour#NULL or should a exception be signaled on the exchange NotFoundBehaviour#EXCEPTION - the default. One of: [EXCEPTION] [NULL] | "EXCEPTION" | false | MEDIUM
| *camel.component.salesforce.notifyForFields* | Notify for fields, options are ALL, REFERENCED, SELECT, WHERE One of: [ALL] [REFERENCED] [SELECT] [WHERE] | null | false | MEDIUM
| *camel.component.salesforce.notifyForOperation Create* | Notify for create operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.component.salesforce.notifyForOperation Delete* | Notify for delete operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.component.salesforce.notifyForOperations* | Notify for operations, options are ALL, CREATE, EXTENDED, UPDATE (API version 29.0) One of: [ALL] [CREATE] [EXTENDED] [UPDATE] | null | false | MEDIUM
| *camel.component.salesforce.notifyForOperation Undelete* | Notify for un-delete operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.component.salesforce.notifyForOperation Update* | Notify for update operation, defaults to false (API version = 29.0) | null | false | MEDIUM
| *camel.component.salesforce.objectMapper* | Custom Jackson ObjectMapper to use when serializing/deserializing Salesforce objects. | null | false | MEDIUM
| *camel.component.salesforce.packages* | In what packages are the generated DTO classes. Typically the classes would be generated using camel-salesforce-maven-plugin. This must be set if using the XML format. Also, set it if using the generated DTOs to gain the benefit of using short SObject names in parameters/header values. Multiple packages can be separated by comma. | null | false | MEDIUM
| *camel.component.salesforce.rawPayload* | Use raw payload String for request and response (either JSON or XML depending on format), instead of DTOs, false by default | false | false | MEDIUM
| *camel.component.salesforce.reportId* | Salesforce1 Analytics report Id | null | false | MEDIUM
| *camel.component.salesforce.reportMetadata* | Salesforce1 Analytics report metadata for filtering | null | false | MEDIUM
| *camel.component.salesforce.resultId* | Bulk API Result ID | null | false | MEDIUM
| *camel.component.salesforce.sObjectBlobFieldName* | SObject blob field name | null | false | MEDIUM
| *camel.component.salesforce.sObjectClass* | Fully qualified SObject class name, usually generated using camel-salesforce-maven-plugin | null | false | MEDIUM
| *camel.component.salesforce.sObjectFields* | SObject fields to retrieve | null | false | MEDIUM
| *camel.component.salesforce.sObjectId* | SObject ID if required by API | null | false | MEDIUM
| *camel.component.salesforce.sObjectIdName* | SObject external ID field name | null | false | MEDIUM
| *camel.component.salesforce.sObjectIdValue* | SObject external ID field value | null | false | MEDIUM
| *camel.component.salesforce.sObjectName* | SObject name if required or supported by API | null | false | MEDIUM
| *camel.component.salesforce.sObjectQuery* | Salesforce SOQL query string | null | false | MEDIUM
| *camel.component.salesforce.sObjectSearch* | Salesforce SOSL search string | null | false | MEDIUM
| *camel.component.salesforce.updateTopic* | Whether to update an existing Push Topic when using the Streaming API, defaults to false | false | false | MEDIUM
| *camel.component.salesforce.config* | Global endpoint configuration - use to set values that are common to all endpoints | null | false | MEDIUM
| *camel.component.salesforce.httpClientProperties* | Used to set any properties that can be configured on the underlying HTTP client. Have a look at properties of SalesforceHttpClient and the Jetty HttpClient for all available options. | null | false | MEDIUM
| *camel.component.salesforce.longPollingTransport Properties* | Used to set any properties that can be configured on the LongPollingTransport used by the BayeuxClient (CometD) used by the streaming api | null | false | MEDIUM
| *camel.component.salesforce.apexUrl* | APEX method URL | null | false | MEDIUM
| *camel.component.salesforce.compositeMethod* | Composite (raw) method. | null | false | MEDIUM
| *camel.component.salesforce.lazyStartProducer* | Whether the producer should be started lazy (on the first message). By starting lazy you can use this to allow CamelContext and routes to startup in situations where a producer may otherwise fail during starting and cause the route to fail being started. By deferring this startup to be lazy then the startup failure can be handled during routing messages via Camel's routing error handlers. Beware that when the first message is processed then creating and starting the producer may take a little time and prolong the total processing time of the processing. | false | false | MEDIUM
| *camel.component.salesforce.autowiredEnabled* | Whether autowiring is enabled. This is used for automatic autowiring options (the option must be marked as autowired) by looking up in the registry to find if there is a single instance of matching type, which then gets configured on the component. This can be used for automatic configuring JDBC data sources, JMS connection factories, AWS Clients, etc. | true | false | MEDIUM
| *camel.component.salesforce.httpProxyExcluded Addresses* | A list of addresses for which HTTP proxy server should not be used. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyHost* | Hostname of the HTTP proxy server to use. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyIncluded Addresses* | A list of addresses for which HTTP proxy server should be used. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyPort* | Port number of the HTTP proxy server to use. | null | false | MEDIUM
| *camel.component.salesforce.httpProxySocks4* | If set to true the configures the HTTP proxy to use as a SOCKS4 proxy. | false | false | MEDIUM
| *camel.component.salesforce.authenticationType* | Explicit authentication method to be used, one of USERNAME_PASSWORD, REFRESH_TOKEN or JWT. Salesforce component can auto-determine the authentication method to use from the properties set, set this property to eliminate any ambiguity. One of: [USERNAME_PASSWORD] [REFRESH_TOKEN] [JWT] | null | false | MEDIUM
| *camel.component.salesforce.clientId* | OAuth Consumer Key of the connected app configured in the Salesforce instance setup. Typically a connected app needs to be configured but one can be provided by installing a package. | null | true | HIGH
| *camel.component.salesforce.clientSecret* | OAuth Consumer Secret of the connected app configured in the Salesforce instance setup. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyAuthUri* | Used in authentication against the HTTP proxy server, needs to match the URI of the proxy server in order for the httpProxyUsername and httpProxyPassword to be used for authentication. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyPassword* | Password to use to authenticate against the HTTP proxy server. | null | false | MEDIUM
| *camel.component.salesforce.httpProxyRealm* | Realm of the proxy server, used in preemptive Basic/Digest authentication methods against the HTTP proxy server. | null | false | MEDIUM
| *camel.component.salesforce.httpProxySecure* | If set to false disables the use of TLS when accessing the HTTP proxy. | true | false | MEDIUM
| *camel.component.salesforce.httpProxyUseDigestAuth* | If set to true Digest authentication will be used when authenticating to the HTTP proxy, otherwise Basic authorization method will be used | false | false | MEDIUM
| *camel.component.salesforce.httpProxyUsername* | Username to use to authenticate against the HTTP proxy server. | null | false | MEDIUM
| *camel.component.salesforce.instanceUrl* | URL of the Salesforce instance used after authentication, by default received from Salesforce on successful authentication | null | false | MEDIUM
| *camel.component.salesforce.keystore* | KeyStore parameters to use in OAuth JWT flow. The KeyStore should contain only one entry with private key and certificate. Salesforce does not verify the certificate chain, so this can easily be a selfsigned certificate. Make sure that you upload the certificate to the corresponding connected app. | null | false | MEDIUM
| *camel.component.salesforce.lazyLogin* | If set to true prevents the component from authenticating to Salesforce with the start of the component. You would generally set this to the (default) false and authenticate early and be immediately aware of any authentication issues. | false | false | MEDIUM
| *camel.component.salesforce.loginConfig* | All authentication configuration in one nested bean, all properties set there can be set directly on the component as well | null | false | MEDIUM
| *camel.component.salesforce.loginUrl* | URL of the Salesforce instance used for authentication, by default set to \https://login.salesforce.com | "https://login.salesforce.com" | true | HIGH
| *camel.component.salesforce.password* | Password used in OAuth flow to gain access to access token. It's easy to get started with password OAuth flow, but in general one should avoid it as it is deemed less secure than other flows. Make sure that you append security token to the end of the password if using one. | null | false | MEDIUM
| *camel.component.salesforce.refreshToken* | Refresh token already obtained in the refresh token OAuth flow. One needs to setup a web application and configure a callback URL to receive the refresh token, or configure using the builtin callback at \https://login.salesforce.com/services/oauth2/success or \https://test.salesforce.com/services/oauth2/success and then retrive the refresh_token from the URL at the end of the flow. Note that in development organizations Salesforce allows hosting the callback web application at localhost. | null | false | MEDIUM
| *camel.component.salesforce.sslContextParameters* | SSL parameters to use, see SSLContextParameters class for all available options. | null | false | MEDIUM
| *camel.component.salesforce.useGlobalSslContext Parameters* | Enable usage of global SSL context parameters | false | false | MEDIUM
| *camel.component.salesforce.userName* | Username used in OAuth flow to gain access to access token. It's easy to get started with password OAuth flow, but in general one should avoid it as it is deemed less secure than other flows. | null | false | MEDIUM
|===



The camel-salesforce sink connector has no converters out of the box.





The camel-salesforce sink connector has no transforms out of the box.





The camel-salesforce sink connector has no aggregation strategies out of the box.
// kafka-connector options: END
